#include "stdafx.h" //MFC
#include "USBRocket.h"
#include "usb.h"  //LibUSB

BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
    switch (ul_reason_for_call)
	  {
		  case DLL_PROCESS_ATTACH:
		  case DLL_THREAD_ATTACH:
		  case DLL_THREAD_DETACH:
		  case DLL_PROCESS_DETACH:
			  break;
    }
    return TRUE;
}


void USBMissileSend(bool links, bool rechts, bool oben, bool unten, bool feuer, int geraetenr)
{
  //Arbeitsvariablen
	struct usb_bus *Bus;
	struct usb_device *Geraet = NULL;
	
	int usbtimeout = 100, counter = -1;

  //LibUSB Initialisierung
	usb_init();
	usb_find_busses();
	usb_find_devices();

  //Enumeration
	struct usb_bus* Busse = usb_get_busses();
	for (Bus = Busse; Bus ; Bus = Bus->next)  //ber alle Busse
	{
		for (Geraet = Bus->devices; Geraet; Geraet = Geraet->next)  //ber alle Gerte pro Bus
		{
			if (Geraet->descriptor.idVendor == 0x1130 && Geraet->descriptor.idProduct == 0x0202)  // 1130:0202
			{
				counter++;
				if (counter == geraetenr) //STOPP, "Geraet" steht nun auf dem ausgewhlten Raketenwerfer
					break;
			}
		}
	}

  //Falls Gert gefunden -> auf Gert zugreifen und Funktionen auslsen
	if (Geraet) 
  {
    //USB Handle aufs Gert
		usb_dev_handle *Raketenwerfer = usb_open(Geraet);

    //Auswahl von Configuration und Interface
		usb_set_configuration(Raketenwerfer, 1);
		usb_claim_interface(Raketenwerfer, 1);

    //Payload zusammensetzen und losschicken, erst Init, dann Eingabe
		char data[64];

    data[0] = 'U';
		data[1] = 'S';
		data[2] = 'B';
		data[3] = 'C';
		data[4] =  0;
		data[5] =  0;
		data[6] =  4;
		data[7] =  0;
		usb_control_msg(Raketenwerfer, USB_DT_HID, USB_REQ_SET_CONFIGURATION, USB_RECIP_ENDPOINT, 1, data, 8, usbtimeout);


		data[0] = 'U';
		data[1] = 'S';
		data[2] = 'B';
		data[3] = 'C';
		data[4] =  0;
		data[5] =  64;
		data[6] =  2;
		data[7] =  0;
		usb_control_msg(Raketenwerfer, USB_DT_HID, USB_REQ_SET_CONFIGURATION, USB_RECIP_ENDPOINT, 1, data, 8, usbtimeout);

    memset(data, 0, 64);
		if (oben) 
      data[3] = 1;
		if (unten)
      data[4] = 1;
		if (links)
      data[1] = 1;
		if (rechts)
      data[2] = 1;
		if (feuer)
      data[5] = 1;

		usb_control_msg(Raketenwerfer, USB_DT_HID, USB_REQ_SET_CONFIGURATION, USB_RECIP_ENDPOINT, 1, data, 64, usbtimeout);

    //Zugriff beenden
		usb_release_interface(Raketenwerfer, 1);
		usb_close(Raketenwerfer);
	}
}

void USBMissileSendAll(bool links, bool rechts, bool oben, bool unten, bool feuer)
{
  //Arbeitsvariablen
	struct usb_bus *Bus;
	struct usb_device *Geraet = NULL;
	
	int usbtimeout = 100, counter = -1;

  //LibUSB Initialisierung
	usb_init();
	usb_find_busses();
	usb_find_devices();

  //Enumeration
	struct usb_bus* Busse = usb_get_busses();
  
	for (Bus = Busse; Bus ; Bus = Bus->next)  //ber alle Busse
	{
		for (Geraet = Bus->devices; Geraet; Geraet = Geraet->next)  //ber alle Gerte pro Bus
		{
			if (Geraet->descriptor.idVendor == 0x1130 && Geraet->descriptor.idProduct == 0x0202)  // 1130:0202
			{
				usb_dev_handle *Raketenwerfer = usb_open(Geraet);

        //Auswahl von Configuration und Interface
		    usb_set_configuration(Raketenwerfer, 1);
		    usb_claim_interface(Raketenwerfer, 1);

        //Payload zusammensetzen und losschicken, erst Init, dann Eingabe
		    char data[64];

        data[0] = 'U';
		    data[1] = 'S';
		    data[2] = 'B';
		    data[3] = 'C';
		    data[4] =  0;
		    data[5] =  0;
		    data[6] =  4;
		    data[7] =  0;
		    usb_control_msg(Raketenwerfer, USB_DT_HID, USB_REQ_SET_CONFIGURATION, USB_RECIP_ENDPOINT, 1, data, 8, usbtimeout);


		    data[0] = 'U';
		    data[1] = 'S';
		    data[2] = 'B';
		    data[3] = 'C';
		    data[4] =  0;
		    data[5] =  64;
		    data[6] =  2;
		    data[7] =  0;
		    usb_control_msg(Raketenwerfer, USB_DT_HID, USB_REQ_SET_CONFIGURATION, USB_RECIP_ENDPOINT, 1, data, 8, usbtimeout);

        memset(data, 0, 64);
		    if (oben) 
          data[3] = 1;
		    if (unten)
          data[4] = 1;
		    if (links)
          data[1] = 1;
		    if (rechts)
          data[2] = 1;
		    if (feuer)
          data[5] = 1;

		    usb_control_msg(Raketenwerfer, USB_DT_HID, USB_REQ_SET_CONFIGURATION, USB_RECIP_ENDPOINT, 1, data, 64, usbtimeout);

        //Zugriff beenden
		    usb_release_interface(Raketenwerfer, 1);
		    usb_close(Raketenwerfer);
			}
		}
	}
}

USBROCKET_API void BewegungLO(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(true, false, true, false, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(true, false, true, false, false);
}

USBROCKET_API void BewegungO(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(false, false, true, false, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(false, false, true, false, false);
}

USBROCKET_API void BewegungRO(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(false, true, true, false, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(false, true, true, false, false);
}

USBROCKET_API void BewegungL(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(true, false, false, false, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(true, false, false, false, false);
}

USBROCKET_API void BewegungR(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(false, true, false, false, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(false, true, false, false, false);
}

USBROCKET_API void BewegungLU(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(true, false, false, true, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(true, false, false, true, false);
}

USBROCKET_API void BewegungU(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(false, false, false, true, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(false, false, false, true, false);
}

USBROCKET_API void BewegungRU(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(false, true, false, true, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(false, true, false, true, false);
}

USBROCKET_API void BewegungSTOP(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(false, false, false, false, false, geraet);
  else if (geraet == -1)
    USBMissileSendAll(false, false, false, false, false);
}

USBROCKET_API void BewegungFEUER(int geraet)
{
  if (geraet >= 0 && geraet < 128)
    USBMissileSend(false, false, false, false, true, geraet);
  else if (geraet == -1)
    USBMissileSendAll(false, false, false, false, true);
}

USBROCKET_API int LauncherCount()
{
	int counter = 0;
	struct usb_bus *Bus;
	struct usb_device *Geraet = NULL;

	usb_init();
	usb_find_busses();
	usb_find_devices();

	struct usb_bus *Busse = usb_get_busses();
	for (Bus = Busse; Bus; Bus = Bus->next)
	{
		for (Geraet = Bus->devices; Geraet; Geraet = Geraet->next)
		{
			if (Geraet->descriptor.idVendor == 0x1130 && Geraet->descriptor.idProduct == 0x0202)
				counter++;
		}
	}

  return counter;
}