#include "stdafx.h"
#include "Massakah.h"
#include "MassakahDlg.h"
#include "usb.h"
#include "USBRocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CMassakahDlg::CMassakahDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMassakahDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMassakahDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMassakahDlg)
	DDX_Control(pDX, IDC_LAUNCHERID, m_LauncherCombobox);
	DDX_Check(pDX, IDC_MULTIFIRE, m_bAlleGeraete);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMassakahDlg, CDialog)
	//{{AFX_MSG_MAP(CMassakahDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LO, OnButtonLo)
	ON_BN_CLICKED(IDC_BUTTON_O, OnButtonO)
	ON_BN_CLICKED(IDC_BUTTON_RO, OnButtonRo)
	ON_BN_CLICKED(IDC_BUTTON_L, OnButtonL)
	ON_BN_CLICKED(IDC_BUTTON_FEUER, OnButtonFeuer)
	ON_BN_CLICKED(IDC_BUTTON_R, OnButtonR)
	ON_BN_CLICKED(IDC_BUTTON_LU, OnButtonLu)
	ON_BN_CLICKED(IDC_BUTTON_U, OnButtonU)
	ON_BN_CLICKED(IDC_BUTTON_RU, OnButtonRu)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_MULTIFIRE, OnAlleGeraete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CMassakahDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetWindowPos(&this->wndTopMost,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	CString test;
	int AnzahlLauncher = LauncherCount();
	for (int i=0; i< AnzahlLauncher; i++)
	{
		test.Format("Launcher %d", i);
		m_LauncherCombobox.AddString(test);
	}

  if (AnzahlLauncher > 0)
    m_LauncherCombobox.SetCurSel(0);

  CButton *pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_O));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_O));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_RO));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RO));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_R));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_R));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_RU));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RU));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_U));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_U));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_LU));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_LU));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_L));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_L));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_LO));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_LO));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_M));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_M));

  pBtn = static_cast<CButton*>(GetDlgItem(IDC_BUTTON_F));
  pBtn->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_F));

	return TRUE;
}

void CMassakahDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CMassakahDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
	  
void CMassakahDlg::OnButtonLo() 
{
    BewegungLO(CheckAuswahl());
}

void CMassakahDlg::OnButtonO() 
{
		BewegungO(CheckAuswahl());
}

void CMassakahDlg::OnButtonRo() 
{
		BewegungRO(CheckAuswahl());
}

void CMassakahDlg::OnButtonL() 
{
		BewegungL(CheckAuswahl());
}

void CMassakahDlg::OnButtonR() 
{
		BewegungR(CheckAuswahl());
}

void CMassakahDlg::OnButtonLu() 
{
		BewegungLU(CheckAuswahl());
}

void CMassakahDlg::OnButtonU() 
{
		BewegungU(CheckAuswahl());
}

void CMassakahDlg::OnButtonRu() 
{
		BewegungRU(CheckAuswahl());
}

void CMassakahDlg::OnButtonStop() 
{
		BewegungSTOP(CheckAuswahl());	
}

void CMassakahDlg::OnButtonFeuer() 
{
		BewegungFEUER(CheckAuswahl());
}

BOOL CMassakahDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message==WM_KEYDOWN)
  {
     if(pMsg->wParam==VK_RETURN || pMsg->wParam==VK_ESCAPE)
         return 0;
     if(pMsg->wParam==VK_NUMPAD7)
         OnButtonLo();
     if(pMsg->wParam==VK_NUMPAD8)
         OnButtonO();
     if(pMsg->wParam==VK_NUMPAD9)
         OnButtonRo();
     if(pMsg->wParam==VK_NUMPAD4)
         OnButtonL();
     if(pMsg->wParam==VK_NUMPAD5)
         OnButtonStop();
     if(pMsg->wParam==VK_NUMPAD6)
         OnButtonR();
     if(pMsg->wParam==VK_NUMPAD1)
         OnButtonLu();
     if(pMsg->wParam==VK_NUMPAD2)
         OnButtonU();
     if(pMsg->wParam==VK_NUMPAD3)
         OnButtonRu();

     if(pMsg->wParam==VK_NUMPAD0)
         OnButtonFeuer();
  }	
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CMassakahDlg::OnAlleGeraete() 
{
  m_bAlleGeraete = !m_bAlleGeraete;
  m_LauncherCombobox.EnableWindow(!m_bAlleGeraete);  
}


int CMassakahDlg::CheckAuswahl()
{
  if (m_bAlleGeraete == TRUE)
    return -1;                                    //alle Gerte
  else if (m_LauncherCombobox.GetCurSel() > -1)
    return m_LauncherCombobox.GetCurSel();        //ausgewhltes Gert
  else 
    return 1337;                                  //kein Gert ausgewhlt
}
